>From 27616d9ea8b8af016b1f7f378964875fe4eb17f5 Mon Sep 17 00:00:00 2001
From: Joseph Tulou <brezhoneg1@yahoo.fr>
Date: Wed, 28 Jan 2009 12:03:03 +0100
Subject: [PATCH] scaling toggle support for windows (not yet tested)

---
 modules/video_output/msw/direct3d.c |   10 ++++++++++
 modules/video_output/msw/directx.c  |   10 ++++++++++
 modules/video_output/msw/glwin32.c  |   10 ++++++++++
 modules/video_output/msw/wingdi.c   |   10 ++++++++++
 4 files changed, 40 insertions(+), 0 deletions(-)

diff --git a/modules/video_output/msw/direct3d.c b/modules/video_output/msw/direct3d.c
index 716b931..b47bbd3 100644
--- a/modules/video_output/msw/direct3d.c
+++ b/modules/video_output/msw/direct3d.c
@@ -446,6 +446,16 @@ static int Manage( vout_thread_t *p_vout )
         p_vout->p_sys->i_changes &= ~DX_POSITION_CHANGE;
     }
 
+    /* Check for scaling/no-scaling change */
+    if( p_vout->i_changes & VOUT_SCALE_CHANGE )
+    {
+        p_vout->i_changes &= ~VOUT_SCALE_CHANGE;
+
+        p_vout->b_scale = var_GetBool( p_vout, "scaling" );
+
+        UpdateRects( p_vout, true );
+    }
+
     /* Check for cropping / aspect changes */
     if( p_vout->i_changes & VOUT_CROP_CHANGE ||
         p_vout->i_changes & VOUT_ASPECT_CHANGE )
diff --git a/modules/video_output/msw/directx.c b/modules/video_output/msw/directx.c
index e324279..ae51f6a 100644
--- a/modules/video_output/msw/directx.c
+++ b/modules/video_output/msw/directx.c
@@ -602,6 +602,16 @@ static int Manage( vout_thread_t *p_vout )
         }
     }
 
+    /* Check for scaling/no-scaling change */
+    if( p_vout->i_changes & VOUT_SCALE_CHANGE )
+    {
+        p_vout->i_changes &= ~VOUT_SCALE_CHANGE;
+
+        p_vout->b_scale = var_GetBool( p_vout, "scaling" );
+
+        UpdateRects( p_vout, true );
+    }
+
     /* Check for cropping / aspect changes */
     if( p_vout->i_changes & VOUT_CROP_CHANGE ||
         p_vout->i_changes & VOUT_ASPECT_CHANGE )
diff --git a/modules/video_output/msw/glwin32.c b/modules/video_output/msw/glwin32.c
index 10f6bd8..b85c6dc 100644
--- a/modules/video_output/msw/glwin32.c
+++ b/modules/video_output/msw/glwin32.c
@@ -305,6 +305,16 @@ static int Manage( vout_thread_t *p_vout )
         vlc_mutex_unlock( &p_vout->p_sys->lock );
     }
 
+    /* Check for scaling/no-scaling change */
+    if( p_vout->i_changes & VOUT_SCALE_CHANGE )
+    {
+        p_vout->i_changes &= ~VOUT_SCALE_CHANGE;
+
+        p_vout->b_scale = var_GetBool( p_vout, "scaling" );
+
+        UpdateRects( p_vout, true );
+    }
+
     /* Check for cropping / aspect changes */
     if( p_vout->i_changes & VOUT_CROP_CHANGE ||
         p_vout->i_changes & VOUT_ASPECT_CHANGE )
diff --git a/modules/video_output/msw/wingdi.c b/modules/video_output/msw/wingdi.c
index ef41f3f..929b116 100644
--- a/modules/video_output/msw/wingdi.c
+++ b/modules/video_output/msw/wingdi.c
@@ -522,6 +522,16 @@ static int Manage( vout_thread_t *p_vout )
         vlc_mutex_unlock( &p_vout->p_sys->lock );
     }
 
+    /* Check for scaling/no-scaling change */
+    if( p_vout->i_changes & VOUT_SCALE_CHANGE )
+    {
+        p_vout->i_changes &= ~VOUT_SCALE_CHANGE;
+
+        p_vout->b_scale = var_GetBool( p_vout, "scaling" );
+
+        UpdateRects( p_vout, true );
+    }
+
     /* Check for cropping / aspect changes */
     if( p_vout->i_changes & VOUT_CROP_CHANGE ||
         p_vout->i_changes & VOUT_ASPECT_CHANGE )
-- 
1.5.2.5

